<?php

/*

  browser4exif2csv 1.03a vom 19.09.2003

  Autor/Kontakt: Jrgen Galupki
  Lizenz:  http://galupki.de/kontakt/readme-kontakt-lizenz.html
  Kontakt: http://galupki.de/kontakt/
  WWW:     http://galupki.de             /foto.html oder /php.html ...

*/

// speichert/liest Angaben zu den Bildern
// Prinzip: Es gibt eine "zentrale" Datei $notes_dirfile, die alle
//          bisher gescannten Verzeichnisse sortiert enthaelt. Jedem Verzeichnis
//          wird eine fixe, fortlaufende Nummer zugewiesen.
//          Fuer jedes Verzeichnis existiert eine eigene sortierte Datei $notes_file.$nr mit
//          Angaben zu den einzelnen Bildern
//          Kategorien und Stichworte knnen je Bild zugewiesen werden (gehen beim kopieren / bewegen
//          von Bildern verloren!)


global $vorschau_verzeichnis;
       $vorschau_verzeichnis = "C:/temp/vorschau/";

global $notes_dirfile;                   // Im Namen MUSS Zeichenkette "dir" einmalig vorkommen. "dir" wird fuer die
       $notes_dirfile = "exif_dir.txt";  // einzelnen Dateien dann durch die jeweilige Nr ersetzt...

global $notes_finished;
global $comment;                         // enthaelt Kategorien und Stichworte je Bild

global $search;                          // Liste von Feldinhalten
global $feldnamen;
global $werte;

global $taglist;                         // hier wird definiert, welche Felder aus $result in welcher Reihenfolge in der CSV
                                         // gespeichert+angezeigt werden sollen. VORSICHT: Um nicht alle Dateien neu
                                         // aufbauen zu mssen (schadet auch nix) Ergnzungen immer hinten dranhngen...

                                         // IMMER am Satzanfang gespeichert werden:

                                         // Bilddatei;Vorschaubild;FileName;year;month;day;hh;mm;kategorie;stichwort;

       $taglist = array(
        "Width_",
        "Height_",
        "ImageRatio_",
        "FileSize",
        "FocalLength",
        "KBFocalLength_",
        "ZoomRatio_",
        "FNumber",
        "ExposureTime",
        "ISO",
        "ExposureBiasValue",
        "MeteringMode",
        "ExposureMode_Canon",
        "EasyShooting",
        "FocusType",
        "FlashActivity",
        "Flash_Canon",
        "PhotoEffect",
        "WhiteBalance_Canon",
        "Quality",
        "dof_Np",
        "SubjectDistance",
        "dof_Fp",
        "Make",
        "Model",
        "OwnerName"
);




function read_csv_comment($nr) {
// liest kategorien und stichworte nach $comment[datei]["K"] und $comment[datei]["S"] falls vorhanden

global $comment;
global $vorschau_verzeichnis;
global $notes_dirfile;

  $datei = $vorschau_verzeichnis . str_replace ( "dir", $nr, $notes_dirfile);

  $comment = array();

  if (file_exists($datei)) {
     $nd = fopen($datei, "rb");
     while ( $data = fgetcsv ($nd, 2048, ";")) {
        $comment[basename($data[0])]["K"] = $data[8];
        $comment[basename($data[0])]["S"] = $data[9];
     }
     fclose($nd);
  }

} // end function read_csv_comments



function copy_csv_file($nr) {
// kopiert die neue notes-Datei von *.new nach *
// "gepuffertes" Schreiben notwendig wg. mglichem Timeout/Fehlern whrend der Ausfhrung
// Kategorien+Stichworte wren verloren, wenn nur eine Datei benutzt wrde...

global $vorschau_verzeichnis;
global $notes_dirfile;
global $notes_finished;


  if ($notes_finished==false) {
     return;
  }

  $src = $vorschau_verzeichnis . str_replace ( "dir", $nr, $notes_dirfile) . ".new";
  $des = $vorschau_verzeichnis . str_replace ( "dir", $nr, $notes_dirfile);

  if (!copy($src, $des)) {
     die ("VORSICHT: failed to copy $src to $des... Verlust Kategorie/Stichwrter droht! VOR NEUSTART ERST PRFEN!<br>\n");
  }  else {
     echo "<h4>Datei $des wurde geschrieben</h4>\n";
     unlink($src);
  }

} // end function copy_csv_file




function write_csv_entry($nr, $bild, $vorschau, $kategorie, $stichwort, $init) {
// ergnzt einen Bildeintrag in eine Directory-Datei

global $vorschau_verzeichnis;
global $notes_dirfile;

global $taglist;
global $result;


  if ($nr<1 and $init==false) {
     echo "<h4>write_csv_entry - keine nr angegeben: '$nr'</h4>";
     return;
  }

  if ($stichwort=="" AND $result['ImageDescription']!="") {
     $stichwort = $result['ImageDescription'];
  }

  $datei = $vorschau_verzeichnis . str_replace ( "dir", $nr, $notes_dirfile);
  if ($notes_finished==false) {
     $datei .= ".new";           // erstmal in einen Puffer schreiben anstelle direkt
  }

  if ($init==true) {
// Datei neu anfangen, nur berschrift mit Feldnamen schreiben und RETURN
     $dh = fopen($datei,"wb");
     fputs($dh, "Bilddatei;Vorschaubild;FileName;year;month;day;hh;mm;kategorie;stichwort;");
     foreach ($taglist as $tag) {
        fputs($dh, $tag . ";" );
     }
     fputs($dh, "\r\n");
     fclose($dh);
     return;
  }

// Append Satz an Datei - Semikolon wird soweit mglich innerhalb Feldern entfernt
  $dh = fopen( $datei, "ab" );
  fputs($dh, $bild . ";" . $vorschau . ";" . $result["FileName"] . ";"
             . $result["year"] . ";" . $result["month"] . ";" . $result["day"] . ";"
             . $result["hh"] . ";" . $result["mm"] . ";"
             . str_replace ( ";", ",", $kategorie) . ";" . str_replace ( ";", ",", $stichwort) . ";");
  foreach ($taglist as $tag) {
     fputs($dh, str_replace ( ";", ",", $result[$tag]) . ";" );
  }
  fputs($dh, "\r\n");
  fclose($dh);

} // end function write_csv_entry



function csv_dirfile($verzeichnis) {
// liefert die Nr. der Verzeichnisdatei zurueck
// ergaenzt das Directory um einen Pfad und die zugehoerige notes-Datei
// falls noetig (also noch nicht vorhanden)

global $vorschau_verzeichnis;
global $notes_dirfile;


//  $verzeichnis = dirname($verzeichnis);

  $Xnotes_dirfile = $vorschau_verzeichnis . $notes_dirfile;

  $eintrag = array();

  $nr = 0;                                             // falls existent
  $newnr = 1;                                          // nchste freie Nummer

  if (file_exists($Xnotes_dirfile)) {
     $nd = fopen($Xnotes_dirfile, "rb");
     while ( $data = fgetcsv ($nd, 1024, ";")) {
        $eintrag[trim($data[0])] = trim($data[1]);
        if (trim($data[0])==$verzeichnis) {
           $nr = trim($data[1]);                       // verzeichnis gefunden; nr wird gesetzt
        }  elseif (trim($data[1])>=$newnr) {
           $newnr = trim($data[1])+1;
        }
     }
     fclose($nd);
  }

  if ($nr==0) {
     $eintrag[$verzeichnis] = $newnr;
     $nr = $newnr;
     ksort($eintrag);
     $nd = fopen($Xnotes_dirfile, "wb");
     foreach ($eintrag as $key => $tmpnr) {
        fputs($nd, $key . ";" . $tmpnr . "\r\n");
     }
     fclose($nd);
  }

  return($nr);

} // endfunction csv_dirfile



function concatenate_csv_files() {
// kopiert alle einzelnen Dateien zusammen

global $vorschau_verzeichnis;
global $notes_dirfile;
global $feldnamen;


  $dirfile = $vorschau_verzeichnis . $notes_dirfile;
  $allfile = $vorschau_verzeichnis . str_replace ( "dir", "all", $notes_dirfile);

  $dateien = 0;
  $verzeichnisse = 0;

  echo "<p>...erzeuge Liste aller Bilder";

  if (file_exists($dirfile)) {
     $hd = fopen($dirfile, "rb");
     $ha = fopen($allfile, "wb");
     while ( $data = fgetcsv ($hd, 1024, ";")) {
        $nr_file = $vorschau_verzeichnis . str_replace ( "dir", trim($data[1]), $notes_dirfile);
        $hn = fopen($nr_file, "rb");
        $verzeichnisse++;
        echo ".";
        $i=0;
        while ( $bilddata = fgets($hn, 2048) ) {
           $i++;
           if ($i>1 OR $verzeichnisse==1) {
              $dateien++;
              fputs($ha, $bilddata);
              $test = explode ( ";", $bilddata);
              if ($i==1 AND $verzeichnisse==1) {
// Feldnamen
                 $fnr = 0;
                 $feldnamen  = array();
                 foreach ($test as $feldname) {
                    $feldnamen[$fnr] = $feldname;
                    $fnr++;
                    $search[$feldname] = array();
                 }
              }  else {
// Inhalte
                 $fnr = 0;
                 while ($fnr<count($test)) {
                       $liste = explode(",",$test[$fnr]);
                       foreach ($liste as $eintrag) {
                          $search[$feldnamen[$fnr]][special_search_fields($feldnamen[$fnr], $eintrag)]++;
                       }
                    $fnr++;
                 }
              }
           }
        }
        fclose($hn);
     }
     fclose($hd);
     fclose($ha);
  }

// Datei mit Selektionsmglichkeiten schreiben
  $searchfile = $vorschau_verzeichnis . str_replace ( "dir", "search", $notes_dirfile);
  $hs = fopen($searchfile, "wb");
  $fnr = 0;
  foreach ($search as $key=>$styp) {
     ksort($search[$key]);
     if ($key>" ") {
        fputs($hs, $key . ";" . $fnr . ";");
        foreach ($search[$key] as $kkey=>$sstyp) {
           if ($kkey!="") {
              fputs($hs, $kkey . ";");
           }
        }
        fputs($hs, "\r\n");
     }
     $fnr++;
  }
  fclose($hs);

  $dateien--;
  echo "\n<p>Datei $allfile<br>Verzeichnisse: $verzeichnisse<br>Dateien: $dateien\n";

} // endfunction concatenate_csv_files



function special_search_fields($feldname, $wert) {
// setzt eventuell Werte um oder unterdrckt sie (weil sonst viel zu viele verschiedene Einzelwerte entstehen wrden)

  $wert = trim($wert);

  if ($feldname=="SubjectDistance") {
     if ($wert=="unendlich") {
        $meter = "unendlich";
     }  elseif ($wert == "") {
        $meter = "?";
     }  elseif ($wert <= 1.0) {
        $meter = "<= 1m";
     }  elseif ($wert <= 5.0) {
        $meter = "<= 5m";
     }  elseif ($wert <= 10.0) {
        $meter = "<=10m";
     }  else {
        $meter = ">10m";
     }
     return $meter;

  }  elseif ($feldname=="FileSize") {
     $mb = "ca. " . sprintf("%01.1f", round(trim($wert)/1000,1)) . " MB";
     return $mb;

  }  elseif ($feldname=="Bilddatei") {
     return strtolower ( strrchr ( dirname($wert), "/"));    // quasi als Stichwortersatz/Ergnzung last Directoryname...

  }  elseif (
             $feldname=="Vorschaubild" OR
             $feldname=="FileName" OR
             $feldname=="dof_Np" OR
             $feldname=="dof_Fp" OR
             $feldname=="mm"
            ) {
     return " ";

  }  else {
     return $wert;
  }

} // end special_search_fields





function get_search_fields($test) {

global $vorschau_verzeichnis;
global $notes_dirfile;
global $feldnamen;
global $werte;


// Datei mit Selektionsmglichkeiten lesen
  $searchfile = $vorschau_verzeichnis . str_replace ( "dir", "search", $notes_dirfile);
  $hs = fopen($searchfile, "rb");

  $feldnamen = array();
  $werte = array();

  while ($data = fgetcsv ($hs, 4096, ";")) {
     $fnr = 0;
     $lfdnr = 0;
     foreach ($data as $entry) {
       if ($fnr>1) {
           $feldnamen[$data[1]]     = $data[0];  // zwar mehrfach, aber dafuer nur falls Wert vorhanden
           $werte[$data[1]][$lfdnr] = $entry;
           $lfdnr++;
       }
       $fnr++;
     }

  }
  fclose($hs);


  if (!$test) return;

  print_r($feldnamen);
  echo "<p>";
  print_r($werte);


}

?>